package cn.com.qmth.dp.examcloud.oe;

import cn.com.qmth.dp.examcloud.oe.util.PropertiesUtil;
import cn.com.qmth.examcloud.web.support.SpringContextHolder;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.autoconfigure.domain.EntityScan;
import org.springframework.boot.autoconfigure.web.servlet.MultipartAutoConfiguration;
import org.springframework.cloud.client.discovery.EnableDiscoveryClient;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.context.annotation.Configuration;
import org.springframework.data.jpa.repository.config.EnableJpaAuditing;
import org.springframework.data.jpa.repository.config.EnableJpaRepositories;
import org.springframework.data.mongodb.config.EnableMongoAuditing;
import org.springframework.data.mongodb.repository.config.EnableMongoRepositories;
import org.springframework.scheduling.annotation.EnableAsync;
import org.springframework.transaction.annotation.EnableTransactionManagement;

/**
 * 启动类
 *
 * @author WANGWEI
 * @date 2019年3月29日
 * @Copyright (c) 2018-? http://qmth.com.cn All Rights Reserved.
 */
@EnableAsync
@Configuration
@EnableJpaAuditing
@EnableMongoAuditing
@EnableTransactionManagement
@EnableDiscoveryClient
@ComponentScan(basePackages = {"cn.com.qmth"})
@EntityScan(basePackages = {"cn.com.qmth"})
@EnableJpaRepositories(basePackages = {"cn.com.qmth"})
@EnableMongoRepositories(basePackages = {"cn.com.qmth"})
@SpringBootApplication(exclude = {MultipartAutoConfiguration.class})
public class OeToolApplication {

    static {
        System.setProperty("hibernate.dialect.storage_engine", "innodb");
        PropertiesUtil.loadFromResource("application.properties");
    }

    public static void main(String[] args) {
        SpringApplication.run(OeToolApplication.class, args);

        // UpyunSiteManager.initSite();
        // UpyunSiteManager.initClient();

        Task task = SpringContextHolder.getBean(Task.class);
        task.start();
    }

}
