package cn.com.qmth.dp.examcloud.oe.modules.export_course_questions_count;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

import org.springframework.stereotype.Service;

import cn.com.qmth.dp.examcloud.oe.excel.ExportUtils;
import cn.com.qmth.dp.examcloud.oe.multithread.Consumer;
import cn.com.qmth.examcloud.web.support.SpringContextHolder;

/**
 * 查找导入的批次。去重、汇总
 * 
 * @author chenken
 *
 */
@Service
public class ExportPaperSuffService {

    private String rootOrgId = "17351";

    private int threadCount = 20;

    private int fileIndex = 0;

    public void start() {
        Date s = new Date();
        PaperSuffProducer pr = SpringContextHolder.getBean(PaperSuffProducer.class);
        try {
            Map<String, Object> param = new HashMap<>();
            param.put("rootOrgId", rootOrgId);
            pr.startDispose(PaperSuffConsumer.class, threadCount, param);
            Set<PaperSuffDto> ret = new HashSet<>();
            for (Consumer c : pr.getConsumers()) {
                ret.addAll(c.getSet());
            }
            FileOutputStream fos = null;
            File file = createFile();
            try {
                file.createNewFile();
                fos = new FileOutputStream(file);
                ExportUtils.makeExcel(PaperSuffDto.class, ret, fos);
            } catch (Exception e) {
                e.printStackTrace();
            } finally {
                if (fos != null) {
                    try {
                        fos.close();
                    } catch (IOException e) {
                        e.printStackTrace();
                    }
                }
            }
            System.out.println("finish! file:" + file.getAbsolutePath());
            Date e = new Date();
            System.out.println("time:" + (e.getTime() - s.getTime()));
        } catch (Exception e) {
            throw new RuntimeException(e);

        }
    }

    private File createFile() {
        String suff = fileIndex == 0 ? "" : (fileIndex + "");
        File file = new File("d:/ret" + suff + ".xlsx");
        if (file.exists()) {
            if (!file.delete()) {
                fileIndex++;
                return createFile();
            }
        }
        return file;
    }
}
