package cn.com.qmth.dp.examcloud.oe.modules.export_course_questions_count;

import java.math.BigDecimal;
import java.math.RoundingMode;

import org.springframework.data.mongodb.core.mapping.Document;

import cn.com.qmth.dp.examcloud.oe.entity.question.MongoBaseEntity;
import cn.com.qmth.dp.examcloud.oe.enums.question.PaperType;
import cn.com.qmth.dp.examcloud.oe.enums.question.QuesStructType;

@Document(collection = "paperDetailUnit")
public class PaperDetailUnitDto extends MongoBaseEntity {

    /**
     * 
     */
    private static final long serialVersionUID = 266448283780973578L;

    private Integer number;// 小题序号

    private Double score;// 小题分数

    private QuesStructType questionType;// 小题类型

    /**
     * 选择题下option的排序,按照number排序 一般：4,2,3,1 套题下的选择题:1,2,3,4;2,3,4,1;3,2,1,4
     * 题与题之间按分号";"分隔
     */
    private String optionOrder;

    private String creator;// 创建人id

    private String createTime;// 创建时间

    private PaperType paperType;

    /**
     * 作答限时 K12
     */
    private Long timeLimit;

    public PaperDetailUnitDto() {
    }

    public Integer getNumber() {
        return number;
    }

    public void setNumber(Integer number) {
        this.number = number;
    }

    public Double getScore() {
        return score;
    }

    public QuesStructType getQuestionType() {
        return questionType;
    }

    public void setQuestionType(QuesStructType questionType) {
        this.questionType = questionType;
    }

    public String getCreator() {
        return creator;
    }

    public void setCreator(String creator) {
        this.creator = creator;
    }

    public String getCreateTime() {
        return createTime;
    }

    public void setCreateTime(String createTime) {
        this.createTime = createTime;
    }

    public String getOptionOrder() {
        return optionOrder;
    }

    public void setOptionOrder(String optionOrder) {
        this.optionOrder = optionOrder;
    }

    public PaperType getPaperType() {
        return paperType;
    }

    public void setPaperType(PaperType paperType) {
        this.paperType = paperType;
    }

    public static double formatDouble(double number) {
        BigDecimal formatNumber = BigDecimal.valueOf(number);
        return formatNumber.setScale(2, RoundingMode.HALF_UP).doubleValue();
    }

    public Long getTimeLimit() {
        return timeLimit;
    }

    public void setTimeLimit(Long timeLimit) {
        this.timeLimit = timeLimit;
    }

}
