package cn.com.qmth.dp.examcloud.oe.modules.export_course_questions_count;

import java.util.List;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import org.apache.commons.collections4.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.data.mongodb.core.MongoTemplate;
import org.springframework.data.mongodb.core.query.Criteria;
import org.springframework.data.mongodb.core.query.Query;
import org.springframework.stereotype.Service;

import cn.com.qmth.dp.examcloud.oe.entity.question.Course;
import cn.com.qmth.dp.examcloud.oe.multithread.Consumer;

@Service
@Scope("prototype")
public class PaperSuffConsumer extends Consumer<Course> {

    private Pattern pa = Pattern.compile("\\(([0-9]{6})\\)");

    @Autowired
    private MongoTemplate mongoTemplate;

    @Override
    public void consume(Map<String, Object> param, Course c) {
        String rootOrgId = (String) param.get("rootOrgId");
        getPaperSuff(c.getCode(), rootOrgId);

    }

    private void getPaperSuff(String courseCode, String rootOrgId) {
        Query query = new Query();
        query.addCriteria(Criteria.where("orgId").is(rootOrgId).and("paperType").is("IMPORT").and("course.code")
                .is(courseCode).and("creationBy").is(646523L));
        List<IdBean> ps = mongoTemplate.find(query, IdBean.class, "paper");
        if (CollectionUtils.isEmpty(ps)) {
            return;
        }
        for (IdBean n : ps) {
            Matcher ma = pa.matcher(n.getName());
            if (ma.find()) {
                addSet(new PaperSuffDto(ma.group(1)));
            }
        }
    }

}
