package cn.com.qmth.dp.examcloud.oe.modules.export_course_questions_count;

import java.util.List;
import java.util.Map;

import org.apache.commons.collections4.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.BeanPropertyRowMapper;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Service;

import cn.com.qmth.dp.examcloud.oe.entity.question.Course;
import cn.com.qmth.dp.examcloud.oe.multithread.Producer;

@Service
public class PaperSuffProducer extends Producer {

	@Autowired
	private JdbcTemplate jdbcTemplate;
	
	@Override
	protected void produce(Map<String, Object> param) throws Exception {
		String rootOrgId=(String)param.get("rootOrgId");
		List<Course> cs = getCourse(rootOrgId);
		System.out.println("courseCount:" + cs.size());
		if (CollectionUtils.isNotEmpty(cs)) {
			for (Course c : cs) {
				offer(c);
			}
		}
		
		
	}
	
	private List<Course> getCourse(String rootOrgId) {
		String sql = "select t.code,t.name,t.id from ec_b_course t where t.root_org_id=" + rootOrgId
				+ " order by t.code";
		RowMapper<Course> rowMapper = new BeanPropertyRowMapper<Course>(Course.class);
		List<Course> ret = jdbcTemplate.query(sql, rowMapper);
		return ret;
	}
	
//	private List<Course> getCourse() {
//		Set<String> set=new HashSet<>();
//		List<Course> list=new ArrayList<>();
//		XSSFWorkbook wb = null;
//		try {
//			wb = new XSSFWorkbook(ResouceUtil.getStream("subject_info.xlsx"));
//			XSSFSheet sheet = wb.getSheetAt(0);
//			int rows = sheet.getLastRowNum();
//			for (int i = 1; i <= rows; i++) {
//				Course c = new Course();
//				XSSFRow row = sheet.getRow(i);
//				String ecCode;
//				try {
//					ecCode = row.getCell(0).getStringCellValue().trim();
//				} catch (Exception e) {
//					ecCode = ((int)row.getCell(0).getNumericCellValue())+"";
//				}
//				String name = row.getCell(2).getStringCellValue().trim();
//				c.setCode(ecCode);
//				c.setName(name);
//				if(!set.contains(ecCode)) {
//					list.add(c);
//					set.add(ecCode);
//				}
//				
//			}
//		} catch (IOException e) {
//			throw new RuntimeException(e);
//		} finally {
//			if (wb != null) {
//				try {
//					wb.close();
//				} catch (IOException e) {
//				}
//			}
//		}
//		return list;
//	}

}
