package cn.com.qmth.dp.examcloud.oe.util;

import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import org.apache.commons.lang3.StringUtils;
import org.jsoup.Jsoup;

import cn.com.qmth.dp.examcloud.oe.modules.findreduplicatequestion.QuesOptionDto;
import cn.com.qmth.dp.examcloud.oe.modules.findreduplicatequestion.QuestionDto;

public class PaperUtil {
	private static Pattern imgPat = Pattern.compile("(<img[^<]+src=['\"])([^<\"]+)(['\"][^<]*>)");

	public static boolean hasImg(QuestionDto question) {
		if (question == null) {
			return false;
		}

		if (hasImg(question.getQuesBody())) {
			return true;
		}

		List<QuesOptionDto> quesOptionList = question.getQuesOptions();
		if (quesOptionList != null && quesOptionList.size() > 0) {
			for (QuesOptionDto quesOption : quesOptionList) {
				if (hasImg(quesOption.getOptionBody())) {
					return true;
				}
			}
		}

		return false;
	}

	public static boolean hasImg(String htmlStr) {
		if(htmlStr==null) {
			return false;
		}
		Matcher matcher = imgPat.matcher(htmlStr);
		if (matcher.find()) {
			return true;
		} else {
			return false;
		}
	}

	public static String getExtractText(String html) {
		if (StringUtils.isBlank(html)) {
			return "";
		}
		return getTextInHtml(html);
	}

	public static String getExtractText(QuestionDto question) {
		StringBuilder quesText = new StringBuilder();
		if (question == null) {
			return quesText.toString();
		}

		if (!StringUtils.isEmpty(question.getQuesBody())) {
			quesText.append(getTextInHtml(question.getQuesBody()));
		}

		List<QuesOptionDto> quesOptionList = question.getQuesOptions();
		if (quesOptionList != null && quesOptionList.size() > 0) {
			for (QuesOptionDto quesOption : quesOptionList) {
				if (!StringUtils.isEmpty(quesOption.getOptionBody())) {
					quesText.append(getTextInHtml(quesOption.getOptionBody()));
				}
			}
		}

		return quesText.toString();
	}

	public static void main(String[] args) {
		String s = "ss<p>1<p>2  6   &nbsp;    3</p><img src='ddd'/></p>";
		System.out.println(getTextInHtml(s));
	}

	private static String getTextInHtml(String htmlStr) {
//		htmlStr = htmlStr.replaceAll("\\&[a-zA-Z]{1,10};", "").trim();
//		if (!htmlStr.startsWith("<p>")) {
//			return htmlStr;
//		}

		org.jsoup.nodes.Document doc = Jsoup.parse(htmlStr);
		return doc.text().replaceAll(" ", "");
	}

}
